--------------------------------------------------------------------------------
-- Company:  Department of Informatics & Telecommunications, University of Western Macedonia
-- Engineer:  Kechagias Apostolos (apkech@gmail.com)
--
-- Create Date:    15:35:40 05/30/2012 
-- Design Name:    
-- Module Name:    controller - Behavioral
-- Project Name:   
-- Target Device:   Xilinx Spartan 3A on Digilent Spartan-3 Starter Kit Board
-- Tool versions: ISE 13.2 
-- Description: This is a controller that runs sdes algorithm and displays the result to vga
-- Dependencies: vga_cntrl, rotary_cntrl, sdes
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--------------------------------------------------------------------------------



library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity controller is
	port(
		clk50_in: in std_logic;
		input: inout std_logic_vector(0 to 17);
		red_out   : out std_logic_vector(3 downto 0);
		green_out : out std_logic_vector(3 downto 0);
		blue_out  : out std_logic_vector(3 downto 0);
		hs_out    : out std_logic;
		vs_out    : out std_logic;
		rotary_a	 : in std_logic;
		rotary_b	 : in std_logic;
		tgl_btn	 : in std_logic;
		reset	 : in std_logic);
end controller;

architecture Behavioral of controller is
component vga_cntrl
  port(
	clk50_in  : in std_logic;
	input   : in std_logic_vector(0 to 17);
	selector: in std_logic_vector(0 to 17);
	cipher    : in std_logic_vector(0 to 7);
	red_out   : out std_logic_vector(3 downto 0);
	green_out : out std_logic_vector(3 downto 0);
	blue_out  : out std_logic_vector(3 downto 0);
	hs_out    : out std_logic;
	vs_out    : out std_logic);
end component;

component sdes
    port(
	clk, rst: std_logic;
	input :in std_logic_vector(0 to 7);
    key: in std_logic_vector(0 to 9);
    output: out std_logic_vector(0 to 7));
end component;

component rotary_cntrl
port (
	outp : out std_logic_vector(0 to 17);
	toggle_btn : in std_logic;
	input : inout std_logic_vector(0 to 17);
	rotary_a : in std_logic;
	rotary_b : in std_logic;
	clk : in std_logic);
end component;

signal output: std_logic_vector(0 to 7);
signal out_rot: std_logic_vector(0 to 17);

begin
alg: sdes port map(clk50_in, reset, input(0 to 7), input(8 to 17),output);
sel: rotary_cntrl port map(out_rot, tgl_btn, input, rotary_a, rotary_b, clk50_in);
vga: vga_cntrl port map(clk50_in, input, out_rot, output, red_out, green_out, blue_out, hs_out, vs_out);

end Behavioral;

